Index: libcfs/libcfs/watchdog.c
===================================================================
RCS file: /cvsroot/cfs/libcfs/libcfs/watchdog.c,v
retrieving revision 1.11
diff -u -p -r1.11 watchdog.c
--- libcfs/libcfs/watchdog.c	21 Jul 2009 17:15:20 -0000	1.11
+++ libcfs/libcfs/watchdog.c	1 Jan 2010 20:03:35 -0000
@@ -43,17 +43,26 @@
 #include <libcfs/libcfs.h>
 #include "tracefile.h"
 
+/** Libcfs watchdog */
 struct lc_watchdog {
-        cfs_timer_t       lcw_timer; /* kernel timer */
+        /** kernel timer */
+        cfs_timer_t       lcw_timer;
+        /** list node to be member of global "pending timers" list */
         struct list_head  lcw_list;
+        /** when (in system ticks) watchdog was touched last time */
         cfs_time_t        lcw_last_touched;
+        /** pointer to the task structure of creator */
         cfs_task_t       *lcw_task;
 
+        /** callback to call when watchdog is triggered */
         void            (*lcw_callback)(pid_t, void *);
+        /** private (consumer-provided) data for \a lcw_callback */
         void             *lcw_data;
 
+        /** process ID of creator */
         pid_t             lcw_pid;
 
+        /** internal state of watchdog */
         enum {
                 LC_WATCHDOG_DISABLED,
                 LC_WATCHDOG_ENABLED,
@@ -100,6 +109,7 @@ static cfs_time_t lcw_last_watchdog_time
 static int lcw_recent_watchdog_count;
 static spinlock_t lcw_last_watchdog_lock = SPIN_LOCK_UNLOCKED;
 
+/** print out stack-trace of watchdog' task if possible */
 static void
 lcw_dump(struct lc_watchdog *lcw)
 {
@@ -128,6 +138,11 @@ lcw_dump(struct lc_watchdog *lcw)
         EXIT;
 }
 
+/**
+ * Libcfs internal callback. Called by linux kernel when timer
+ * associated with given watchdog got expired.
+ * \param data pointer to libcfs watchdog structure which timer got expired
+ */
 static void lcw_cb(ulong_ptr_t data)
 {
         struct lc_watchdog *lcw = (struct lc_watchdog *)data;
@@ -193,6 +208,12 @@ static void lcw_cb(ulong_ptr_t data)
         EXIT;
 }
 
+/**
+ * Check if any fired watchdog presents or shutdown is in progress.
+ * Used only as condition for conditional wait on lcw_event_waitq.
+ * \return 1 if any fired watchdog presents or shutdown is in
+ * progress, 0 otherwise
+ */
 static int is_watchdog_fired(void)
 {
         int rc;
@@ -206,6 +227,7 @@ static int is_watchdog_fired(void)
         return rc;
 }
 
+/** Stand-alone thread checking for fired watchdogs */
 static int lcw_dispatch_main(void *data)
 {
         int                 rc = 0;
@@ -263,6 +285,10 @@ static int lcw_dispatch_main(void *data)
         RETURN(rc);
 }
 
+/**
+ * Start stand-alone dispatch thread.
+ * Waits until the thread is really started.
+ */
 static void lcw_dispatch_start(void)
 {
         int rc;
@@ -287,6 +313,10 @@ static void lcw_dispatch_start(void)
         EXIT;
 }
 
+/**
+ * Shutdown stand-alone dispatch thread.
+ * Waits until the thread is really shutdown.
+ */
 static void lcw_dispatch_stop(void)
 {
         ENTRY;
@@ -304,6 +334,20 @@ static void lcw_dispatch_stop(void)
         EXIT;
 }
 
+/**
+ * Create and register new watchdog in Libcfs watchdog system.
+ * This is the start point of life-cycle of any watchdog.
+ *
+ * \param timeout not used for now
+ * \param callback user-defined callback to be called when watchdog
+ * got expired or NULL to use default libcfs watchdog callback
+ * \param data private data for user-defined callback
+ *
+ * \return pointer to newly created watchdog
+ *
+ * NOTE: watchdog is created in 'DISABLED' state, should be enabled
+ * explicitly with lc_watchdog_touch.
+ */
 struct lc_watchdog *lc_watchdog_add(int timeout,
                                     void (*callback)(pid_t, void *),
                                     void *data)
@@ -359,6 +403,15 @@ static void lcw_update_time(struct lc_wa
         lcw->lcw_last_touched = newtime;
 }
 
+/**
+ * Enable watchdog and reset its timer. Should be called in two cases:
+ * - to enable watchdog after creation
+ * - to advance expiration point in time
+ *
+ * \param lcw pointer to libcfs watchdog
+ * \param timeout how long (in seconds) expiration time should be
+ * advanced (from 'now')
+ */
 void lc_watchdog_touch(struct lc_watchdog *lcw, int timeout)
 {
         ENTRY;
@@ -378,6 +431,11 @@ void lc_watchdog_touch(struct lc_watchdo
 }
 EXPORT_SYMBOL(lc_watchdog_touch);
 
+/**
+ * Disable watchdog pointed by \a lcw. Libcfs won't pay attention to
+ * given watchdog anymore (at least, till it's re-enabled again with
+ * lc_watchdog_touch)
+ */
 void lc_watchdog_disable(struct lc_watchdog *lcw)
 {
         ENTRY;
@@ -395,6 +453,7 @@ void lc_watchdog_disable(struct lc_watch
 }
 EXPORT_SYMBOL(lc_watchdog_disable);
 
+/** De-register \a lcw from libcfs watchdog system and destroy \a lcw */
 void lc_watchdog_delete(struct lc_watchdog *lcw)
 {
         ENTRY;
Index: libcfs/libcfs/linux/linux-curproc.c
===================================================================
RCS file: /cvsroot/cfs/libcfs/libcfs/linux/linux-curproc.c,v
retrieving revision 1.7
diff -u -p -r1.7 linux-curproc.c
--- libcfs/libcfs/linux/linux-curproc.c	20 Nov 2008 12:51:23 -0000	1.7
+++ libcfs/libcfs/linux/linux-curproc.c	1 Jan 2010 20:03:35 -0000
@@ -76,6 +76,7 @@ pid_t  cfs_curproc_pid(void)
         return current->pid;
 }
 
+/** returns # groups current then current process is member of */
 int    cfs_curproc_groups_nr(void)
 {
         int nr;
@@ -90,6 +91,11 @@ int    cfs_curproc_groups_nr(void)
         return nr;
 }
 
+/**
+ * Store in \a array the gid-s of all groups that current process is member of
+ * \param array where to store gid-s
+ * \param size # gid-s \a array can afford
+ */
 void   cfs_curproc_groups_dump(gid_t *array, int size)
 {
 #if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,4)
@@ -139,6 +145,7 @@ int cfs_cap_raised(cfs_cap_t cap)
         return cap_raised(cfs_current()->cap_effective, cfs_cap_unpack(cap));
 }
 
+/** get capabilities of current process */
 cfs_cap_t cfs_curproc_cap_pack(void)
 {
 #if defined (_LINUX_CAPABILITY_VERSION) && _LINUX_CAPABILITY_VERSION == 0x19980330
@@ -153,6 +160,7 @@ cfs_cap_t cfs_curproc_cap_pack(void)
 #endif
 }
 
+/** set capabilities for current process */
 void cfs_curproc_cap_unpack(cfs_cap_t cap)
 {
 #if defined (_LINUX_CAPABILITY_VERSION) && _LINUX_CAPABILITY_VERSION == 0x19980330
@@ -166,6 +174,7 @@ void cfs_curproc_cap_unpack(cfs_cap_t ca
 #endif
 }
 
+/** check if user is capable to perform actions reflected in \a cap */
 int cfs_capable(cfs_cap_t cap)
 {
         return capable(cfs_cap_unpack(cap));
Index: libcfs/libcfs/linux/linux-fs.c
===================================================================
RCS file: /cvsroot/cfs/libcfs/libcfs/linux/linux-fs.c,v
retrieving revision 1.3
diff -u -p -r1.3 linux-fs.c
--- libcfs/libcfs/linux/linux-fs.c	7 Aug 2008 14:48:53 -0000	1.3
+++ libcfs/libcfs/linux/linux-fs.c	1 Jan 2010 20:03:35 -0000
@@ -43,6 +43,16 @@
 
 #include <libcfs/libcfs.h>
 
+/**
+ * Open a file by name from kernel
+ *
+ * \param name Path to the file
+ * \param flags Access modes (like O_CREAT, O_EXCL, O_WRONLY, etc.)
+ * \param mode Permissions to use in case of creation (e.g. 0600)
+ * \param err if not NULL, status of operation will be saved there
+ *
+ * \return Libcfs file descriptor on success, NULL otherwise
+ */
 cfs_file_t *
 cfs_filp_open (const char *name, int flags, int mode, int *err)
 {
@@ -65,8 +75,18 @@ cfs_filp_open (const char *name, int fla
 	return filp;
 }
 
-/* write a userspace buffer to disk.
- * NOTE: this returns 0 on success, not the number of bytes written. */
+/**
+ * Write a user-space buffer to disk.
+ *
+ * \param filp Libcfs file descriptor
+ * \param buf Pointer to buffer to write
+ * \param count # bytes of \a buf to write
+ * \param offset Offset from the beginning of file where write will start
+ *
+ * \return  0 on success, negative error code otherwise
+ *
+ * NOTE: this returns 0 on success, not the number of bytes written.
+ */
 ssize_t
 cfs_user_write (cfs_file_t *filp, const char *buf, size_t count, loff_t *offset)
 {
Index: libcfs/libcfs/linux/linux-kernelcomm.c
===================================================================
RCS file: /cvsroot/cfs/libcfs/libcfs/linux/linux-kernelcomm.c,v
retrieving revision 1.5
diff -u -p -r1.5 linux-kernelcomm.c
--- libcfs/libcfs/linux/linux-kernelcomm.c	26 Oct 2009 08:08:25 -0000	1.5
+++ libcfs/libcfs/linux/linux-kernelcomm.c	1 Jan 2010 20:03:35 -0000
@@ -64,8 +64,10 @@ static struct sock *lnl_socket = NULL;
 static atomic_t lnl_start_count = ATOMIC_INIT(0);
 static spinlock_t lnl_lock = SPIN_LOCK_UNLOCKED;
 
-/** Start the netlink socket for this transport
- * @param transport lnl_transport
+/**
+ * Start the netlink socket for this transport
+ * \param transport lnl_transport
+ * \return 0 if OK, negative error value otherwise
  */
 int libcfs_klnl_start(int transport)
 {
@@ -115,9 +117,13 @@ static void send_shutdown_msg(int transp
         libcfs_klnl_msg_put(0, group, &lh);
 }
 
-/* This should be called once per (started) transport
- * @param transport lnl_transport
- * @param group Broadcast group for shutdown message */
+/**
+ * Stop the netlink socket for this transport
+ *  This should be called once per (started) transport
+ * \param transport lnl_transport
+ * \param group Broadcast group for shutdown message
+ * \return 0 (always)
+ */
 int libcfs_klnl_stop(int transport, int group)
 {
         if (group)
@@ -164,11 +170,12 @@ static struct sk_buff *netlink_make_msg(
 }
 
 /**
- * libcfs_klnl_msg_put - send an message from kernel to userspace
- * @param pid Process id to send message to for unicast messages; must be 0 for
+ * Send an message from kernel to user-space
+ * \param pid Process id to send message to for unicast messages; must be 0 for
  *   broadcast
- * @param group Broadcast group; 0 for unicast messages
- * @param payload Payload data.  First field of payload is always struct lnl_hdr
+ * \param group Broadcast group; 0 for unicast messages
+ * \param payload Payload data.  First field of payload is always struct lnl_hdr
+ * \return 0 if OK, negative error value otherwise
  *
  * Allocates an skb, builds the netlink message, and sends it to the pid.
  */
Index: libcfs/libcfs/linux/linux-mem.c
===================================================================
RCS file: /cvsroot/cfs/libcfs/libcfs/linux/linux-mem.c,v
retrieving revision 1.6
diff -u -p -r1.6 linux-mem.c
--- libcfs/libcfs/linux/linux-mem.c	26 Oct 2009 08:08:26 -0000	1.6
+++ libcfs/libcfs/linux/linux-mem.c	1 Jan 2010 20:03:35 -0000
@@ -41,6 +41,12 @@
 #include <linux/highmem.h>
 #include <libcfs/libcfs.h>
 
+/**
+ * Convert libcfs alloc flags (defined in enum cfs_alloc_flags)
+ * to linux native representation.
+ * \param flags Flag combination to convert
+ * \return linux representation of \a flag
+ */
 static unsigned int cfs_alloc_flags_to_gfp(u_int32_t flags)
 {
 	unsigned int mflags = 0;
@@ -100,6 +106,7 @@ cfs_free_large(void *addr)
 	vfree(addr);
 }
 
+/** return array of 2^order pages */
 cfs_page_t *cfs_alloc_pages(unsigned int flags, unsigned int order)
 {
         /*
@@ -114,6 +121,15 @@ void __cfs_free_pages(cfs_page_t *page, 
         __free_pages(page, order);
 }
 
+/**
+ * Create memory cache (SLAB allocator)
+ *
+ * \param name some descriptive name of cache
+ * \param size size of objects in this cache
+ * \param offset required alignment for the objects
+ * \param flags SLAB flags (like SLAB_HWCACHE_ALIGN)
+ * \return ptr to the cache on success, NULL on failure
+ */
 cfs_mem_cache_t *
 cfs_mem_cache_create (const char *name, size_t size, size_t offset,
                       unsigned long flags)
Index: libcfs/libcfs/linux/linux-prim.c
===================================================================
RCS file: /cvsroot/cfs/libcfs/libcfs/linux/linux-prim.c,v
retrieving revision 1.10
diff -u -p -r1.10 linux-prim.c
--- libcfs/libcfs/linux/linux-prim.c	26 Oct 2009 08:08:26 -0000	1.10
+++ libcfs/libcfs/linux/linux-prim.c	1 Jan 2010 20:03:35 -0000
@@ -225,10 +225,13 @@ void cfs_daemonize(char *str) {
 
         lock_kernel();
         daemonize(str);
+
+        /* block all signals */
         SIGNAL_MASK_LOCK(current, flags);
         sigfillset(&current->blocked);
         RECALC_SIGPENDING;
         SIGNAL_MASK_UNLOCK(current, flags);
+
         unlock_kernel();
 }
 
@@ -236,7 +239,13 @@ int cfs_daemonize_ctxt(char *str) {
         struct task_struct *tsk = current;
         struct fs_struct *fs = NULL;
 
+        /* among other things, re-parents tsk->fs to init's fs structure */
         cfs_daemonize(str);
+
+        /*
+         * clone init's fs struct to have a local copy that caller
+         * can safely modify afterwards
+         */
         fs = copy_fs_struct(tsk->fs);
         if (fs == NULL)
                 return -ENOMEM;
Index: libcfs/libcfs/linux/linux-tcpip.c
===================================================================
RCS file: /cvsroot/cfs/libcfs/libcfs/linux/linux-tcpip.c,v
retrieving revision 1.5
diff -u -p -r1.5 linux-tcpip.c
--- libcfs/libcfs/linux/linux-tcpip.c	26 Oct 2009 08:08:26 -0000	1.5
+++ libcfs/libcfs/linux/linux-tcpip.c	1 Jan 2010 20:03:35 -0000
@@ -102,6 +102,19 @@ libcfs_sock_ioctl(int cmd, unsigned long
         return rc;
 }
 
+/**
+ * Query interface for its IP-address and status (up/down).
+ *
+ * \param name String with name of interface to query
+ * \param up On successful return, status of interface is saved here.
+ * 1 if "up", 0 if "down".
+ * \param ip On successful return, IP-address of interface is saved
+ * here (in host byte-order).
+ * \param mask On successful return, netmask of interface is saved
+ * here (in host byte-order).
+ *
+ * \return 0 if OK, negative error code otherwise
+ */
 int
 libcfs_ipif_query (char *name, int *up, __u32 *ip, __u32 *mask)
 {
@@ -164,6 +177,20 @@ libcfs_ipif_query (char *name, int *up, 
 
 EXPORT_SYMBOL(libcfs_ipif_query);
 
+/**
+ * Builds array of names of all known IP-interfaces.
+ *
+ * The caller usually defines a variable of (char **) type and passes
+ * its address as \a namesp. Upon successful return, the variable will
+ * be updated pointing at the array of strings (every slot in the
+ * array is the name of some IP-interface). The array must be freed after
+ * use by means of libcfs_ipif_free_enumeration.
+ *
+ * \param namesp On successful return, the address of array of names
+ * is saved here.
+ *
+ * \return # elements in the array if OK, negative error code otherwise
+ */
 int
 libcfs_ipif_enumerate (char ***namesp)
 {
@@ -279,6 +306,20 @@ libcfs_ipif_free_enumeration (char **nam
 
 EXPORT_SYMBOL(libcfs_ipif_free_enumeration);
 
+/**
+ * Write data to the socket
+ *
+ * \param sock Socket to write data to
+ * \param buffer Source buffer
+ * \param nob # bytes to write
+ * \param timeout Maximum time interval (in seconds) before return -ETIMEDOUT
+ *
+ * \return 0 if OK, negative error code otherwise
+ *
+ * NOTE: The function requests blocking send with timeout
+ * specified. If send returns zero in spite of it, the function treats
+ * such situation as erroneous and returns -ECONNABORTED.
+ */
 int
 libcfs_sock_write (struct socket *sock, void *buffer, int nob, int timeout)
 {
@@ -353,6 +394,19 @@ libcfs_sock_write (struct socket *sock, 
 }
 EXPORT_SYMBOL(libcfs_sock_write);
 
+/**
+ * Read data from the socket
+ *
+ * \param sock Socket to read data from
+ * \param buffer Buffer to store data
+ * \param nob # bytes to read
+ * \param timeout Maximum time interval (in seconds) before return -ETIMEDOUT
+ *
+ * \return 0 if OK, negative error code otherwise
+ *
+ * NOTE: If remote end-point closes connection before \a nob bytes
+ * read, the function returns -ECONNRESET.
+ */
 int
 libcfs_sock_read (struct socket *sock, void *buffer, int nob, int timeout)
 {
@@ -420,6 +474,24 @@ libcfs_sock_read (struct socket *sock, v
 
 EXPORT_SYMBOL(libcfs_sock_read);
 
+/**
+ * Create TCP socket and bind it to \a local_ip / \a local_port
+ *
+ * The failure to create and bind may be fatal or not as the function
+ * indicates storing one or zero in \a fatal. For now, any failure
+ * related to creation is treated as fatal, while "EADDRINUSE" failure
+ * to bind is treated as not fatal.
+ *
+ * Created socket must be freed after use by means of libcfs_sock_release.
+ *
+ * \param sockp On successful return, the address of newly created
+ * connected socket is saved here.
+ * \param fatal Points to a flag where "fatality" of operation to be saved
+ * \param local_ip IP-address to bind socket to
+ * \param local_port TCP-port to bind socket to
+ *
+ * \return 0 if OK, negative error code otherwise
+ */
 static int
 libcfs_sock_create (struct socket **sockp, int *fatal,
                     __u32 local_ip, int local_port)
@@ -516,6 +588,11 @@ libcfs_sock_setbuf (struct socket *sock,
 
 EXPORT_SYMBOL(libcfs_sock_setbuf);
 
+/**
+ * If \a remote is zero, stores ip/port of local end-point of
+ * TCP-connection in \a ip / \a port. Otherwise, ip/port of
+ * remote end.
+ */
 int
 libcfs_sock_getaddr (struct socket *sock, int remote, __u32 *ip, int *port)
 {
@@ -559,6 +636,19 @@ libcfs_sock_getbuf (struct socket *sock,
 
 EXPORT_SYMBOL(libcfs_sock_getbuf);
 
+/**
+ * Create cfs_socket, bind it and start listening.
+ *
+ * Created socket must be freed after use by means of libcfs_sock_release.
+ *
+ * \param sockp On successful return, the address of newly created
+ * socket is saved here.
+ * \param local_ip IP-address to bind socket to
+ * \param local_port TCP port to bind socket to
+ * \param backlog maxim number of outstanding connection requests allowed
+ *
+ * \return 0 if OK, negative error code otherwise
+ */
 int
 libcfs_sock_listen (struct socket **sockp,
                     __u32 local_ip, int local_port, int backlog)
@@ -601,6 +691,17 @@ int sock_create_lite(int family, int typ
 }
 #endif
 
+/**
+ * Create socket, accept incoming TCP connection
+ *
+ * Created socket must be freed after use by means of libcfs_sock_release.
+ *
+ * \param newsockp On successful return, the address of newly created
+ * socket (end-point of newly accepted TCP-connection) is saved here.
+ * \param sock Socket where consumer is listening
+ *
+ * \return 0 if OK, negative error code otherwise
+ */
 int
 libcfs_sock_accept (struct socket **newsockp, struct socket *sock)
 {
@@ -646,6 +747,7 @@ libcfs_sock_accept (struct socket **news
 
 EXPORT_SYMBOL(libcfs_sock_accept);
 
+/** wake up thread sleeping in accept(\a sock) */
 void
 libcfs_sock_abort_accept (struct socket *sock)
 {
@@ -654,6 +756,27 @@ libcfs_sock_abort_accept (struct socket 
 
 EXPORT_SYMBOL(libcfs_sock_abort_accept);
 
+/**
+ * Create TCP socket, bind it to \a local_ip / \a local_port and
+ * connect it to \a peer_ip / \a peer_port
+ *
+ * The failure to create/bind/connect may be fatal or not as the function
+ * indicates storing one or zero in \a fatal. The most types of
+ * failures are treated as fatal. The only exception is when bind or
+ * connect fails because of "port already in use" situation.
+ *
+ * Created socket must be freed after use by means of libcfs_sock_release.
+ *
+ * \param sockp On successful return, the address of newly created, bound
+ * and connected socket is saved here.
+ * \param fatal Points to a flag where "fatality" of operation to be saved
+ * \param local_ip IP-address to bind socket to
+ * \param local_port TCP-port to bind socket to
+ * \param peer_ip IP-address of remote peer to connect socket to
+ * \param peer_port TCP-port of remote peer to connect socket to
+ *
+ * \return 0 if OK, negative error code otherwise
+ */
 int
 libcfs_sock_connect (struct socket **sockp, int *fatal,
                      __u32 local_ip, int local_port,
Index: libcfs/libcfs/ulinux/ulinux-kernelcomm.c
===================================================================
RCS file: /cvsroot/cfs/libcfs/libcfs/ulinux/ulinux-kernelcomm.c,v
retrieving revision 1.4
diff -u -p -r1.4 ulinux-kernelcomm.c
--- libcfs/libcfs/ulinux/ulinux-kernelcomm.c	19 Sep 2009 18:36:18 -0000	1.4
+++ libcfs/libcfs/ulinux/ulinux-kernelcomm.c	1 Jan 2010 20:03:35 -0000
@@ -53,10 +53,12 @@
 #include <sys/socket.h>
 #include <linux/netlink.h>
 
-/** Start the userspace side of a LNL pipe.
- * @param link Private descriptor for pipe/socket.
- * @param groups LNL broadcast group to listen to
+/**
+ * Start the user-space side of a LNL pipe.
+ * \param link Private descriptor for pipe/socket.
+ * \param groups LNL broadcast group to listen to
  *          (can be null for unicast to this pid)
+ * \return 0 if OK, negative error value otherwise
  */
 int libcfs_ulnl_start(lustre_netlink *link, int groups)
 {
@@ -86,14 +88,16 @@ int libcfs_ulnl_stop(lustre_netlink *lin
         return close(*link);
 }
 
-/** Read a message from the netlink layer.
+/**
+ * Read a message from the netlink layer.
  * Allocates memory, returns handle
  *
- * @param link Private descriptor for pipe/socket.
- * @param maxsize Maximum message size allowed
- * @param transport Only listen to messages on this transport
+ * \param link Private descriptor for pipe/socket.
+ * \param maxsize Maximum message size allowed
+ * \param transport Only listen to messages on this transport
  *      (and the generic transport)
- * @param lnlhh Handle to the new LNL message
+ * \param lnlhh Handle to the new LNL message
+ * \return 0 if OK, negative error value otherwise
  */
 int libcfs_ulnl_msg_get(lustre_netlink *link, int maxsize, int transport,
                         struct lnl_hdr **lnlhh)
@@ -149,7 +153,7 @@ int libcfs_ulnl_msg_get(lustre_netlink *
         return rc;
 }
 
-/* Free a message returned by the above fn */
+/** Free a message returned by the above fn */
 int libcfs_ulnl_msg_free(struct lnl_hdr **lnlhh)
 {
         /* compute nlmsdghdr offset */
